<template>
  <div class="autocomplete"
    :class="{'autocomplete--opened': opened}">
    <input class="wp-input__field" type="text" v-model="text"
      :placeholder="$props.placeholder" :disabled="$props.disabled"
      @focus="onFocus" @input="onInput"
      v-on-click-outside="onUnfocus">
    <div v-if="opened" class="dropdown-list">
      <div class="dropdown-item" v-for="item in itemsForSelect" :key="item.prop"
        @click="selectItem(item)">
        {{ item.text }}
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'WpAutocomplete',
  props: {
    value: {
      required: true,
    },
    placeholder: {
      type: String,
      default: '',
    },
    items: {
      type: Array,
      default: () => [],
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      text: '',
      opened: false,
    };
  },
  computed: {
    rawVal: {
      set(change) {
        this.$emit('input', change);
      },
      get() {
        return this.$props.value;
      },
    },
    activeItem() {
      return this.$props.items.find(item => item.prop === this.$props.value);
    },
    itemsForSelect() {
      return this.$props.items.filter(
        item => item.text.toLowerCase().indexOf(this.text.toLowerCase()) !== -1,
      );
    },
  },
  methods: {
    onFocus() {
      if (this.text.length > 0 && this.rawVal === undefined) {
        this.opened = true;
      }
      this.$emit('focus');
    },
    onUnfocus() {
      if (this.text.length > 0 && this.rawVal !== undefined) {
        this.text = this.activeItem.text;
      }
      this.opened = false;
      this.$emit('unfocus');
    },
    onInput() {
      if (this.text.length > 0) {
        if (this.itemsForSelect.length === 1) {
          this.selectItem(this.itemsForSelect[0]);
        } else {
          this.opened = true;
        }
      } else {
        this.opened = false;
        this.rawVal = undefined;
      }
    },
    selectItem(item) {
      this.rawVal = item.prop;
      this.text = item.text;
      this.opened = false;
      this.$emit('unfocus');
      this.$emit('select', item.prop);
    },
  },
  watch: {
    rawVal(to) {
      if (to === undefined) {
        this.text = '';
      }
    },
  },
  mounted() {
    if (this.$props.value || this.$props.value === null) {
      if (this.$props.items.length !== 0) {
        this.text = this.$props.items.find(
          item => item.prop === this.$props.value,
        ).text;
      }
    }
  },
};
</script>

<style lang="scss" scoped>
.autocomplete {
  position: relative;
  flex: 1;
  width: 100%;
  display: flex;
  justify-content: flex-start;
  align-items: center;
  font-family: $roboto;
  font-size: 20px;

  .wp-input__field {
    width: 100%;
    height: 30px;
    color: #000;
    font-size: 20px;
    font-family: $roboto;
    border: none;
    outline: none;

    &::placeholder {
      color: $neutralDarker;
    }

  }

  .dropdown {

    &-item {
      height: 30px;
      display: flex;
      justify-content: flex-start;
      align-items: center;
      transition: background ease-in-out .2s, color ease-in-out .2s;

      &--active {
        flex: 1;
        color: #000;

        &:hover {
          cursor: pointer;
        }

      }

      &--placeholder {
        flex: 1;
        color: $neutralDark;

        &:hover {
          cursor: pointer;
        }

      }

    }

    &-list {
      z-index: 100;
      position: absolute;
      top: 35px;
      left: -20px;
      max-height: 75px;
      width: 100%;
      background: #fff;
      font-size: 15px;
      overflow-y: scroll;
      scrollbar-width: none;
      -ms-overflow-style: none;
      border-radius: 5px;
      box-shadow: 0px 0px 10px -3px #000;

      &::-webkit-scrollbar {
        display: none;
      }

      .dropdown-item {
        padding-left: 20px;

        &:hover {
          color: #fff;
          background: $primary;
          cursor: pointer;
        }

      }

    }

  }

}
</style>
